from object import Object
import time

class App(Object):
    def __init__(self):
        Object.__init__(self, None, "app")
        
        self.defaultVar('timeToRun',-1)
        
    def run(self):
        try:
            self.preInit()
            
            self.setVar("shutdown",False)
            startTime = time.time()
            lastTime = startTime
            frameCount = 0
            gfxServer = self.getFirstObjectOfName("gfxServer")
            
            while not self.getVar("shutdown") and (self.getVar('timeToRun') < 0 or time.time() < startTime + self.getVar('timeToRun')):
                frameCount += 1
                currentTime = time.time()
                dtime = currentTime - lastTime
                lastTime = currentTime
                
                self.preUpdate(currentTime - startTime,dtime)
                
                if gfxServer:
                    gfxServer.preRender()
                    gfxServer.render(self)
                    gfxServer.postRender()
                
            totalTime = time.time() - startTime
            fps = float(frameCount) / totalTime
            self.log("%d frames in %f secs = %f fps" % (frameCount,totalTime,fps))
            
        finally:
            self.setVar('shutdown',True)
            self.preDestroy()
