from object import Object

class Camera(Object):
    def __init__(self, parent, type = None, name = None):
        Object.__init__(self, parent, type, name)
        
        self.addInitDepend("GfxServer")
        self.addInitDepend("InputServer")
        
        self.defaultVar("speed",100)
        
    def init(self):
        self.gfxServer = self.getFirstObjectOfName("GfxServer")
        self.inputServer = self.getFirstObjectOfName("InputServer")
        
        if self.inputServer:
            self.inputServer.subscribe(self)
            
    def messageKeyCharDown(self, key):
        if self.gfxServer:
            speed = self.getVar("speed")
            if key == 'a':
                self.gfxServer.setVar('camerax',self.gfxServer.getVar('camerax')-speed)
            elif key == 'd':
                self.gfxServer.setVar('camerax',self.gfxServer.getVar('camerax')+speed)
            elif key == 'w':
                self.gfxServer.setVar('cameray',self.gfxServer.getVar('cameray')-speed)
            elif key == 's':
                self.gfxServer.setVar('cameray',self.gfxServer.getVar('cameray')+speed)
