from object import Object
import curses, threading

class InputThread(threading.Thread):
    def __init__(self, inputServer):
        threading.Thread.__init__(self)
        
        self.inputServer = inputServer
        
    def run(self):
        gfxServer = self.inputServer.getFirstObjectOfName("gfxServer")
        while gfxServer and not self.inputServer.getRoot().getVar("shutdown"):
            key = gfxServer.screen.getch()
            self.inputServer.handleKey(key)

class CursesInputServer(Object):
    def __init__(self, parent):
        Object.__init__(self, parent, "cursesInputServer", "inputServer")
        
        self.addInitDepend("gfxServer")
        self.inputThread = None
        
    def init(self):
        self.gfxServer = self.getFirstObjectOfName("gfxServer")
        if self.gfxServer:
            self.inputThread = InputThread(self)
            self.inputThread.start()
        
    def destroy(self):
        if self.inputThread:
            self.inputThread.join(0)
        
    def handleKey(self, key):
        self.publish("key",key)
        self.publish("keyCharDown",chr(key))
        self.publish("keyCharUp",chr(key))

