from object import Object
from explosion import Explosion

class ExplosionServer(Object):
    def __init__(self, parent, type = None, name = None):
        Object.__init__(self, parent, type, name)
        
        self.defaultVar("sound","explosion.wav")
        
        self.addInitDepend("soundServer")
        
    def init(self):
        self.soundServer = self.getFirstObjectOfName("soundServer")
        
    def messageSpawn(self, msg):
        pos, size, vol = msg
        explosion = Explosion(self)
        explosion.setVar("pos",pos)
        explosion.setVar("size",size)
        
        if self.soundServer and vol:
            self.soundServer.receiveMessage("play",(self.getVar("sound"),vol))
