from object import Object

from pygame import joystick

class Joystick(Object):
    def __init__(self, parent, type = None, name = None):
        Object.__init__(self,parent,type,name)
        
        self.defaultVar("numJoysticks",0)
        
        self.addInitDepend("gfxServer")
        
        self.joysticks = []
        
    def init(self):
        joystick.init()
        self.setVar("numJoysticks",joystick.get_count())
        for i in range(joystick.get_count()):
            js = joystick.Joystick(i)
            js.init()
            self.joysticks.append(js)
        
    def getNumAxes(self, joy = 0):
        return self.joysticks[joy].get_numaxes()
    
    def getAxis(self, axis, joy = 0):
        return self.joysticks[joy].get_axis(axis)
    
    def getNumButtons(self, joy = 0):
        return self.joysticks[joy].get_numbuttons()
    
    def getButton(self, button, joy = 0):
        return self.joysticks[joy].get_button(button)
