from sceneNode import SceneNode
import vector

class Powerup(SceneNode):
    def __init__(self, parent, type = None, name = None):
        SceneNode.__init__(self, parent, type, name)
        
        self.defaultVar("speed",10.0)
        self.defaultVar("hitRadius",10)
        
        self.addInitDepend("gfxServer")
        self.addInitDepend("player")
        
    def init(self):
        self.gfxServer = self.getFirstObjectOfName("gfxServer")
        if self.gfxServer:
            self.screenw = self.gfxServer.getVar("screenw")
            self.screenh = self.gfxServer.getVar("screenh")
        else:
            self.screenw = self.screenh = 100
            
        self.player = self.getFirstObjectOfName("player")
        
        self.gfx = self.makeGfx()
        
    def update(self, time, dtime):
        x,y,z = pos = self.getVar("pos")
        y += self.getVar("speed") * dtime
        self.setVar("pos",(x,y,z))
        
        if y > self.screenh:
            self.deleteThis()
            
        if self.player:
            playerPos = self.player.getVar("pos")
            dist = vector.length(vector.sub(pos,playerPos))
            
            if dist < self.getVar("hitRadius") + self.player.getVar("hitRadius"):
                self.onPlayerCollide()
                self.deleteThis()
                
    def onPlayerCollide(self):
        pass
        
    def makeGfx(self):
        pass
