from object import Object
from joystick import Joystick
import pygame

class PygameInputServer(Object):
    def __init__(self, parent):
        Object.__init__(self, parent, "pygameInputServer", "inputServer")
        self.addInitDepend("gfxServer")
        
        self.joystick = Joystick(self)
        
    def update(self, time, dtime):
        for event in pygame.event.get():
            
            if event.type == pygame.QUIT:
                self.log("shutting down")
                self.getRoot().setVar("shutdown",True)
                
            elif event.type == pygame.KEYDOWN:
                #self.log("keyDown %s" % event.key)
                self.publish("keyDown",event.key)
                if event.key < 256:
                    self.publish("keyCharDown",chr(event.key))
                    
            elif event.type == pygame.KEYUP:
                #self.log("keyUp %s" % event.key)
                self.publish("keyUp",event.key)
                if event.key < 256:
                    self.publish("keyCharUp",chr(event.key))

