import math

def dist(v1, v2):
    sum = 0
    for f1, f2 in zip(v1,v2):
        sum += (f2 - f1) * (f2 - f1)
    return math.sqrt(sum)
    
def thTo(v1, v2):
    return math.atan2(v2[1] - v1[1], v2[0] - v1[0])

def project(v, th, dist):
    v[0] = v[0] + dist * math.cos(th)
    v[1] = v[1] + dist * math.sin(th)
    return v

def th(v):
    return math.atan2(v[1],v[0])

def length(v):
    sum = 0
    for f in v:
        sum += f * f
    return math.sqrt(sum)
    
def normalize(v):
    l = length(v)
    if l:
        newv = []
        for i in range(len(v)):
            newv.append(v[i] / l)
        return tuple(newv)
    else:
        return v

def scale(v, f):
    return [i * f for i in v]

def add(v1, v2):
    return [f1 + f2 for f1, f2 in zip(v1,v2)]

def sub(v1, v2):
    return [f1 - f2 for f1, f2 in zip(v1,v2)]

def dot(v1, v2):
    return [f1 * f2 for f1, f2 in zip(v1,v2)]

def fix(v, minv, maxv):
    newv = []
    for f, minf, maxf in zip(v,minv,maxv):
        r = maxf - minf
        while f < minf:
            f += r
        while f > maxf:
            f -= r
        newv.append(f)
    return tuple(newv)
